#!/usr/bin/perl

$last_d = 0;

while (<>) {
	chop;
	chop if (/\r$/);
	if (/^M30$/) {
	} elsif (/^%/) {
	} elsif (/^T([0-9]+)C([0-9]*.[0-9]*)/) {
		$t = $1;
		$size = $2;
		if (exists($size_tab{"$size"})) {
			$t2 = $size_tab{"$size"};
			$conv_tab{"$t"} = $t2;
		} else {
			$t2 = $last_d + 1;
			$last_d ++;
			$size_tab{"$size"} = $t2;
			$conv_tab{"$t"} = $t2;
			$s = sprintf("T%02dC%s\r\n",$t2,$size);
			$dri_tab = $dri_tab.$s;
			push(@dri_list,$t2);
		}
	} elsif (/^T([0-9]+)$/) {
		$t = $1;
		$t2 = $conv_tab{"$t"};
	}elsif (/^X([0-9]+)Y([0-9]+)/) {
		$x = $1;
		$y = $2;
		$s = sprintf("X%dY%d\r\n",$x,$y);
		$dri{"$t2"} = $dri{"$t2"}.$s;
	} else {
		$s = sprintf("%s\r\n",$_);
		$head = $head.$s;
	}
}
printf("%%\r\n");
print $head;
print $dri_tab;
printf("%%\r\n");
while ($#dri_list >= 0) {
	$t2 = $dri_list[0];
	printf("T%02d\r\n",$t2);
	shift(@dri_list);
	print($dri{"$t2"});
}
printf("M30\r\n");
